<template>
	<div>
		<input type="text" class="searchbox" ref="searchbox" placeholder="Ingresa una dirección"/>
		<div ref="map" style="width: 100%; height: 250px;"></div>
	</div>
</template>
<script lang="ts">
import { Component, Model, Prop, Vue } from 'vue-property-decorator'
import { Loader, LoaderOptions } from 'google-maps'

@Component({})
export default class Map extends Vue {
	@Model('change', Object) readonly location!: firebase.firestore.GeoPoint
	@Prop({ default: [] }) readonly libraries!: Array<string>

	marker = {}
	options: LoaderOptions = { libraries: this.libraries }
	loader = new Loader(process.env.VUE_APP_GOOGLEMAPS_KEY, this.options)
	google = window.google

	async initMap() {
		if (!this.google) {
			this.google = await this.loader.load()
		}
		const map = new this.google.maps.Map(this.$refs.map as Element, {
			center: { lat: this.location.latitude, lng: this.location.longitude },
			zoom: 15,
			mapTypeId: 'roadmap',
			disableDefaultUI: true
		})
		const pin = new this.google.maps.Marker({
			position: { lat: this.location.latitude, lng: this.location.longitude },
			map
		})
		this.$emit('getLocation', { lat: this.location.latitude, lng: this.location.longitude })
		map.addListener('click', evt => {
			pin.setPosition(evt.latLng)
			this.marker = { lat: evt.latLng.lat(), lng: evt.latLng.lng() }
			this.$emit('getLocation', this.marker)
		})
		const input = this.$refs.searchbox as HTMLInputElement
		const searchBox = new this.google.maps.places.SearchBox(input)
		map.controls[this.google.maps.ControlPosition.TOP_CENTER].push(this.$refs.searchbox as HTMLInputElement)
		map.addListener('bounds_changed', () => {
			searchBox.setBounds(map.getBounds() as google.maps.LatLngBounds)
		})
        const geocoder = new this.google.maps.Geocoder();
        const bounds = new this.google.maps.LatLngBounds()
        pin.addListener('position_changed', () => {
            geocoder.geocode({ location: pin.getPosition() || undefined }, (result, status) => {
                if (status == 'OK') {
					this.$emit('getLocationData', result)
                }
            })
        })
		searchBox.addListener('places_changed', () => {
            const places = searchBox.getPlaces()
			if (places.length == 0) {
				return
			}
			places.forEach(place => {
				if (!place.geometry) {
					return
				}
				pin.setPosition(place.geometry.location)
				this.marker = { lat: place.geometry.location.lat(), lng: place.geometry.location.lng() }
				this.$emit('getLocation', this.marker)
				if (place.geometry.viewport) {
					bounds.union(place.geometry.viewport)
				} else {
					bounds.extend(place.geometry.location)
				}            
			})
			map.fitBounds(bounds)
		})
	}

	async mounted() {
		await this.initMap()
	}
}
</script>
<style lang="scss" scoped>
    .searchbox {
        width: 90%;
        padding: 1em !important;
        margin: 1em !important;
        box-sizing: border-box;
        border: 0;
        border-radius: 10px;
        color: rgba(117, 112, 112, 1);
        font-size: 16px;
        font-weight: bold;
    }
</style>
